package net.minecraft.server;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Random;

public class SAPI {
	
	public static void showText() {
		if (!usingText) {
			System.out.println("Using ShockAhPI r5.1");
            usingText = true;
		}
	}
	
	public static MinecraftServer getMinecraftInstance()
    {
        if(instance == null)
            try {
                ThreadGroup threadgroup = Thread.currentThread().getThreadGroup();
                int i = threadgroup.activeCount();
                Thread athread[] = new Thread[i];
                threadgroup.enumerate(athread);
                int j = 0;
                do {
                    if(j >= athread.length)
                        break;
                    if(athread[j].getName().equals("Server thread")) {
                    	instance = ((ThreadServerApplication)athread[j]).a;
                        break;
                    }
                    j++;
                } while(true);
            }
            catch(Exception exception) {
                exception.printStackTrace();
            }
        return instance;
    }
	
	public static void interceptAdd(IInterceptHarvest iinterceptharvest) {
        harvestIntercepts.add(iinterceptharvest);
    }
	
	public static boolean interceptHarvest(World world, EntityHuman entityhuman, Loc loc, int i, int j) {
        for(Iterator<IInterceptHarvest> iterator = harvestIntercepts.iterator(); iterator.hasNext();) {
            IInterceptHarvest iinterceptharvest = iterator.next();
            if(iinterceptharvest.canIntercept(world, entityhuman, loc, i, j)) {
                iinterceptharvest.intercept(world, entityhuman, loc, i, j);
                return true;
            }
        }
        return false;
    }
	
	public static void drop(World world, Loc loc, ItemStack itemstack)
    {
        for(int i = 0; i < itemstack.count; i++) {
            float f = 0.7F;
            double d = (double)(world.random.nextFloat() * f) + (double)(1.0F - f) * 0.5D;
            double d1 = (double)(world.random.nextFloat() * f) + (double)(1.0F - f) * 0.5D;
            double d2 = (double)(world.random.nextFloat() * f) + (double)(1.0F - f) * 0.5D;
            EntityItem entityitem = new EntityItem(world, (double)loc.x() + d, (double)loc.y() + d1, (double)loc.z() + d2, new ItemStack(itemstack.id, 1, itemstack.getData()));
            entityitem.pickupDelay = 10;
            world.addEntity(entityitem);
        }
    }
	
	public static void interceptAdd(IInterceptBlockSet iinterceptblockset)
    {
        setIntercepts.add(iinterceptblockset);
    }

    public static int interceptBlockSet(World world, Loc loc, int i)
    {
        for(Iterator<IInterceptBlockSet> iterator = setIntercepts.iterator(); iterator.hasNext();)
        {
            IInterceptBlockSet iinterceptblockset = iterator.next();
            if(iinterceptblockset.canIntercept(world, loc, i))
            {
                return iinterceptblockset.intercept(world, loc, i);
            }
        }

        return i;
    }

    public static void reachAdd(IReach ireach)
    {
        reaches.add(ireach);
    }

    public static float reachGet(EntityPlayer entityplayer)
    {
    	ItemStack itemstack = entityplayer.inventory.getItemInHand();
        for(Iterator<IReach> iterator = reaches.iterator(); iterator.hasNext();)
        {
            IReach ireach = iterator.next();
            if(ireach.reachItemMatches(itemstack))
            {
                return ireach.getReach(itemstack);
            }
        }

        return 4F;
    }
    
    public static void dungeonAddMob(String s)
    {
        dungeonAddMob(s, 10);
    }

    public static void dungeonAddMob(String s, int i)
    {
        for(int j = 0; j < i; j++)
        {
            dngMobs.add(s);
        }

    }

    public static void dungeonRemoveMob(String s)
    {
        for(int i = 0; i < dngMobs.size(); i++)
        {
            if(((String)dngMobs.get(i)).equals(s))
            {
                dngMobs.remove(i);
                i--;
            }
        }

    }

    public static void dungeonRemoveAllMobs()
    {
        dngAddedMobs = true;
        dngMobs.clear();
    }

    static void dungeonAddDefaultMobs()
    {
        for(int i = 0; i < 10; i++)
        {
            dngMobs.add("Skeleton");
        }

        for(int j = 0; j < 20; j++)
        {
            dngMobs.add("Zombie");
        }

        for(int k = 0; k < 10; k++)
        {
            dngMobs.add("Spider");
        }

    }

    public static String dungeonGetRandomMob()
    {
        if(!dngAddedMobs)
        {
            dungeonAddDefaultMobs();
            dngAddedMobs = true;
        }
        if(dngMobs.isEmpty())
        {
            return "Pig";
        } else
        {
            return (String)dngMobs.get((new Random()).nextInt(dngMobs.size()));
        }
    }

    public static void dungeonAddItem(DungeonLoot dungeonloot)
    {
        dungeonAddItem(dungeonloot, 100);
    }

    public static void dungeonAddItem(DungeonLoot dungeonloot, int i)
    {
        for(int j = 0; j < i; j++)
        {
            dngItems.add(dungeonloot);
        }

    }

    public static void dungeonAddGuaranteedItem(DungeonLoot dungeonloot)
    {
        dngGuaranteed.add(dungeonloot);
    }

    public static int dungeonGetAmountOfGuaranteed()
    {
        return dngGuaranteed.size();
    }

    public static DungeonLoot dungeonGetGuaranteed(int i)
    {
        return (DungeonLoot)dngGuaranteed.get(i);
    }

    public static void dungeonRemoveItem(int i)
    {
        for(int j = 0; j < dngItems.size(); j++)
        {
            if(((DungeonLoot)dngItems.get(j)).loot.id == i)
            {
                dngItems.remove(j);
                j--;
            }
        }

        for(int k = 0; k < dngGuaranteed.size(); k++)
        {
            if(((DungeonLoot)dngGuaranteed.get(k)).loot.id == i)
            {
                dngGuaranteed.remove(k);
                k--;
            }
        }

    }

    public static void dungeonRemoveAllItems()
    {
        dngAddedItems = true;
        dngItems.clear();
        dngGuaranteed.clear();
    }

    static void dungeonAddDefaultItems()
    {
        for(int i = 0; i < 100; i++)
        {
            dngItems.add(new DungeonLoot(new ItemStack(Item.SADDLE)));
        }

        for(int j = 0; j < 100; j++)
        {
            dngItems.add(new DungeonLoot(new ItemStack(Item.IRON_INGOT), 1, 4));
        }

        for(int k = 0; k < 100; k++)
        {
            dngItems.add(new DungeonLoot(new ItemStack(Item.BREAD)));
        }

        for(int l = 0; l < 100; l++)
        {
            dngItems.add(new DungeonLoot(new ItemStack(Item.WHEAT), 1, 4));
        }

        for(int i1 = 0; i1 < 100; i1++)
        {
            dngItems.add(new DungeonLoot(new ItemStack(Item.SULPHUR), 1, 4));
        }

        for(int j1 = 0; j1 < 100; j1++)
        {
            dngItems.add(new DungeonLoot(new ItemStack(Item.STRING), 1, 4));
        }

        for(int k1 = 0; k1 < 100; k1++)
        {
            dngItems.add(new DungeonLoot(new ItemStack(Item.BUCKET)));
        }

        dngItems.add(new DungeonLoot(new ItemStack(Item.GOLDEN_APPLE)));
        for(int l1 = 0; l1 < 50; l1++)
        {
            dngItems.add(new DungeonLoot(new ItemStack(Item.REDSTONE), 1, 4));
        }

        for(int i2 = 0; i2 < 5; i2++)
        {
            dngItems.add(new DungeonLoot(new ItemStack(Item.GOLD_RECORD)));
        }

        for(int j2 = 0; j2 < 5; j2++)
        {
            dngItems.add(new DungeonLoot(new ItemStack(Item.GREEN_RECORD)));
        }

    }

    public static ItemStack dungeonGetRandomItem()
    {
        if(!dngAddedItems)
        {
            dungeonAddDefaultItems();
            dngAddedItems = true;
        }
        if(dngItems.isEmpty())
        {
            return null;
        } else
        {
            return ((DungeonLoot)dngItems.get((new Random()).nextInt(dngItems.size()))).getStack();
        }
    }

    private static MinecraftServer instance;
    public static boolean usingText = false;
    private static List<IInterceptHarvest> harvestIntercepts = new ArrayList<IInterceptHarvest>();
    private static List<IInterceptBlockSet> setIntercepts = new ArrayList<IInterceptBlockSet>();
    private static List<IReach> reaches = new ArrayList<IReach>();
    private static List<String> dngMobs = new ArrayList<String>();
    private static List<DungeonLoot> dngItems = new ArrayList<DungeonLoot>();
    private static List<DungeonLoot> dngGuaranteed = new ArrayList<DungeonLoot>();
    private static boolean dngAddedMobs = false;
    private static boolean dngAddedItems = false;
    
    static 
    {
        PlayerAPI.RegisterPlayerBase(PlayerBaseSAPI.class);
        showText();
    }
}
